# bigquery-advanced-utils

![Build Status](https://img.shields.io/github/actions/workflow/status/Alessio-Siciliano/bigquery-advanced-utils/ci.yml?branch=main)
![License](https://img.shields.io/badge/license-GNU%20GPL%20v3-blue)
![Version](https://img.shields.io/github/v/release/Alessio-Siciliano/bigquery-advanced-utils)
![PyPI](https://img.shields.io/pypi/v/bigquery-advanced-utils)
![Issues](https://img.shields.io/github/issues/Alessio-Siciliano/bigquery-advanced-utils)
![Contributors](https://img.shields.io/github/contributors/Alessio-Siciliano/bigquery-advanced-utils)
![PyLint](https://img.shields.io/github/workflow/status/Alessio-Siciliano/bigquery-advanced-utils/PyLint?label=PyLint&logo=python)
![Black](https://img.shields.io/github/workflow/status/Alessio-Siciliano/bigquery-advanced-utils/BlackLint?label=Black&logo=python)

**BigQuery-advanced-utils** is a lightweight utility library that extends the official Google BigQuery Python client.  
It simplifies tasks like **query management**, *data processing*, and *automation*.  

Aimed at **developers** and **data scientists**, the project is open to *contributions* to improve and enhance its functionality.

## Why This Library?

I created **bigquery-advanced-utils** because I often found myself facing complex or uncommon tasks when working with BigQuery, and there was little or no support available online. Rather than spending time reinventing the wheel, I decided to create this library to help others avoid the same challenges. I hope that everyone can contribute in the same spirit, so feel free to get involved and make this library even better!

## Planned features
- A new query builder.
- Custom data transformation and processing functions.
- Exclusive features with datatransfer.
- Utility functions to manipulate strings and query.

## Installation
Install `bigquery-advanced-utils` via pip:
```bash
pip install bigquery-advanced-utils
```

## Requirements
- Python 3.10+
- Google Cloud BigQuery client library

## Contributing

We are always open to contributions! Whether you have a bug fix, a feature request, or a general improvement to make, your help is appreciated. Here are some ways you can contribute:

- **Bug reports**: Help us catch issues before they affect users.
- **New features**: Suggest new functionalities that could improve the usability of the package.
- **Code improvements**: Review the code and suggest optimizations or fixes.

Please follow the [contributing guide](CONTRIBUTING.md) for more details on how to get started.

## License
This project is licensed under the **GNU General Public License**. See the [LICENSE](LICENSE) file for details.


## Contact
For questions or feedback, feel free to open an issue or reach out to me.
